<template>
  <div v-click-outside="closeModal">
    <div class="qr-wrapper">
      <div class="qr-content">
        <div class="close-btn" @click="closeModal"></div>

        <qrcode ref="qrcode" :value="modalData.address" :options="{ size: 160 }"></qrcode>
        <p class="title">{{ $t('common.modal.qr.title', {currency: modalData.title.toUpperCase()}) }}</p>
        <p class="address">{{ modalData.address }}</p>

        <div class="group-btn">
          <div class="group-item">
            <p class="show-qr-btn" @click="saveQrCode">
              <span class="btn__text">{{ $t('common.modal.qr.btn_save') }}</span>
              <a ref="qrCodeUrl"></a>
            </p>
          </div>
          
          <div class="group-item" v-clipboard:copy="modalData.address" @click="isShowTooltip = !isShowTooltip"
                 v-tooltip="{content: 'Copied', trigger: 'click',boundariesElement: 'window',show: isShowTooltip , classes: ['hide', 'hideAnim']}">
            <p class="copy-btn">
              <span class="btn__text">{{ $t('common.modal.qr.btn_copy') }}</span>
            </p>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  export default {
    props: {
      modalData: {
        type: Object,
      }
    },
    data () {
      return {
        isShowTooltip: false,
      };
    },
    methods: {
      closeModal() {
        this.$broadcast('close-modal', this);
      },
      saveQrCode() {
        if (!this.$refs.qrcode || !this.$refs.qrcode.$el) {
          return;
        }
        this.$refs.qrCodeUrl.setAttribute('download', `${this.modalData.address}.png`);
        this.$refs.qrCodeUrl.setAttribute('href', this.$refs.qrcode.$el.toDataURL('image/png').replace('image/png', 'image/octet-stream'));
        this.$refs.qrCodeUrl.click();
      }
    },
  };
</script>

<style scoped lang="scss">
  @import '../../../../sass/_variables.scss';
  .group-btn {
    font-size: 0;
    margin: 0 -2.5rem;
    padding: 0 18rem;

    .group-item {
      display: inline-block;
      width: 50%;
      padding: 0 2.5rem;
    }
  }

  .show-qr-btn,
  .copy-btn {
    cursor: pointer;
    border-radius: 30rem;
    border: solid 1rem #da6400;
    transition: all 0.3s ease-in-out;
    text-align: center;
    box-sizing: content-box;

    .iconmo-copy,
    .iconmo-QRcode {
      vertical-align: middle;
    }
    
    .btn__text {
      font-size: $tiny;
      vertical-align: middle;
      text-transform: uppercase;
      font-weight: bold;
      line-height: 2.5;
      letter-spacing: 0.5rem;
      color: #fa7300;
    }
  }

  .copy-btn {
    padding: 1rem;
    border: none;
    background-color: #fa7300;
    .btn__text {
      color: #fff;
    }
  }
  
  .iconmo-QRcode {
    font-size: 16rem;
  }

  .iconmo-copy {
    font-size: 16rem;
    &:before {
      color: #fff;
    }
  }

  .qr-content {
    width: 270rem;
    height: 400rem;
    background-color: #f7f7f7;
    box-shadow: 0 2rem 25rem 0 rgba(0, 0, 0, 0.12);
    text-align: center;
    padding-top: 61rem;
    position: fixed;
    top: 50%;
    border-radius: 10rem;
    left: 50%;
    transform: translate(-50%, -50%);

    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: -2rem;
      margin-top: 10rem;
    }

    .address {
      padding: 0 30rem;
      word-break: break-all;
      font-size: $small;
      font-weight: bold;
      color: $black;
      margin-bottom: 30rem;
    }
  }


  .close-btn {
    display: block;
    background-color: #fff;
    border-radius: 50%;
    width: 20rem;
    height: 20rem;
    position: relative;
    position: absolute;
    right: 10rem;
    top: 10rem;
    cursor: pointer;

    &:before,
    &:after {
      content: '';
      display: block;
      height: 1rem;
      width: 9rem;
      position: absolute;
      background-color: #989898;
      left: 50%;
      top: 50%;
      transform: translate(-50%, -50%) rotateZ(45deg);
    }

    &:after {
      transform: translate(-50%, -50%) rotateZ(135deg);
    }
  }
</style>